Index: /pjproject/trunk/build.symbian/bld.inf
===================================================================
--- /pjproject/trunk/build.symbian/bld.inf	(revision 4477)
+++ /pjproject/trunk/build.symbian/bld.inf	(revision 4478)
@@ -32,6 +32,3 @@
 /* Applications */
 //symsndtest.mmp
-symbian_ua.mmp
-..\pjsip-apps\src\symbian_ua_gui\group\symbian_ua_gui.mmp
-gnumakefile ..\pjsip-apps\src\symbian_ua_gui\group\Icons_aif_scalable_dc.mk
 pjlib_test.mmp
Index: project/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- /pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 4477)
+++ 	(revision )
@@ -1,84 +1,0 @@
-// These part may be overwritten by automated test
-// =BEGIN
-#define SND_HAS_APS	0
-#define SND_HAS_VAS	0
-#define SND_HAS_MDA	1
-// =END
-
-TARGET 			symbian_ua.exe
-TARGETTYPE 		exe
-//UID			0x0 0x200235D3
-UID			0x0 0xA000000D
-
-SOURCEPATH		..\pjsip-apps\src\symbian_ua
-
-OPTION			ARMCC --gnu
-
-MACRO			PJ_M_I386=1
-MACRO			PJ_SYMBIAN=1
-
-// Source files
-
-SOURCE			ua.cpp
-SOURCE			main_symbian.cpp
-
-DOCUMENT 		ua.h
-
-START RESOURCE  	symbian_ua_reg.rss
-	TARGETPATH      \private\10003a3f\apps
-END
-
-SYSTEMINCLUDE		..\pjlib\include
-SYSTEMINCLUDE		..\pjlib-util\include
-SYSTEMINCLUDE		..\pjnath\include
-SYSTEMINCLUDE		..\pjmedia\include
-SYSTEMINCLUDE		..\pjsip\include
-
-SYSTEMINCLUDE		\epoc32\include
-SYSTEMINCLUDE		\epoc32\include\libc
-
-// Ordering static libs based on dependencies, most to least dependent,
-// this could be necessary for some SDKs, e.g: S60 3rd MR
-STATICLIBRARY		pjsua_lib.lib
-STATICLIBRARY		pjsip_ua.lib pjsip_simple.lib pjsip.lib
-STATICLIBRARY		libgsmcodec.lib libspeexcodec.lib 
-STATICLIBRARY		libg7221codec.lib libpassthroughcodec.lib
-STATICLIBRARY		pjmedia.lib
-STATICLIBRARY		pjmedia_audiodev.lib
-STATICLIBRARY		pjsdp.lib
-STATICLIBRARY		pjnath.lib
-STATICLIBRARY		pjlib_util.lib pjlib.lib
-STATICLIBRARY		libsrtp.lib
-STATICLIBRARY		libresample.lib
-
-#if SND_HAS_APS
-	LIBRARY		APSSession2.lib
-#endif
-
-#if SND_HAS_VAS
-	LIBRARY		VoIPAudioIntfc.lib		
-#endif
-
-#if SND_HAS_MDA
-	LIBRARY 	mediaclientaudiostream.lib
-	LIBRARY 	mediaclientaudioinputstream.lib
-#endif
-
-#if SND_HAS_APS || SND_HAS_VAS
-	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment MultimediaDD
-#else
-	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment
-#endif
-	
-#ifdef WINSCW
-	STATICLIBRARY   eexe.lib ecrt0.lib
-#endif
-
-LIBRARY			esock.lib insock.lib charconv.lib euser.lib estlib.lib commdb.lib apengine.lib 
-LIBRARY			securesocket.lib x509.lib crypto.lib x500.lib 
-LIBRARY			hal.lib efsrv.lib
-
-// The default 8KB seems to be insufficient with all bells and
-// whistles turned on
-EPOCSTACKSIZE		12288
-
Index: project/trunk/build.symbian/symbian_ua.pkg
===================================================================
--- /pjproject/trunk/build.symbian/symbian_ua.pkg	(revision 4477)
+++ 	(revision )
@@ -1,19 +1,0 @@
-; symbian_ua.pkg
-
-; Languages
-&EN
-
-; Header
-;#{"symbian_ua"},(0x200235D3), 0, 1, 1
-#{"symbian_ua"},(0xA000000D), 0, 1, 1
-
-; Platform compatibility
-[0x101F7961], *, *, *,{"Series60ProductID"}
-
-; vendor
-%{"PJSIP"}
-:"PJSIP"
-
-; Target
-"$(EPOCROOT)Epoc32\release\$(PLATFORM)\$(TARGET)\symbian_ua.exe"-"!:\sys\bin\symbian_ua.exe"
-"$(EPOCROOT)Epoc32\data\z\private\10003a3f\apps\symbian_ua_reg.rSC"-"!:\private\10003a3f\import\apps\symbian_ua_reg.rSC"
Index: project/trunk/build.symbian/symbian_ua_udeb.pkg
===================================================================
--- /pjproject/trunk/build.symbian/symbian_ua_udeb.pkg	(revision 4477)
+++ 	(revision )
@@ -1,21 +1,0 @@
-; symbian_ua_udeb.pkg
-
-; for Carbide development, please use symbian_ua.pkg for comfortness
-; (epoc32 path, platform, and target are set automatically using env vars)
-
-; Languages
-&EN
-
-; Header
-#{"symbian_ua"},(0x200235D3), 0, 1, 1
-
-; Platform compatibility
-[0x101F7961], *, *, *,{"Series60ProductID"}
-
-; vendor
-%{"PJSIP"}
-:"PJSIP"
-
-; Target
-"C:\Symbian\9.2\S60_3rd_FP1\epoc32\release\gcce\UDEB\symbian_ua.exe"-"!:\sys\bin\symbian_ua.exe"
-"C:\Symbian\9.2\S60_3rd_FP1\epoc32\data\z\private\10003a3f\apps\symbian_ua_reg.rSC"-"!:\private\10003a3f\import\apps\symbian_ua_reg.rSC"
Index: project/trunk/build.symbian/symbian_ua_urel.pkg
===================================================================
--- /pjproject/trunk/build.symbian/symbian_ua_urel.pkg	(revision 4477)
+++ 	(revision )
@@ -1,21 +1,0 @@
-; symbian_ua.pkg
-
-; for Carbide development, please use symbian_ua.pkg for comfortness
-; (epoc32 path, platform, and target are set automatically using env vars)
-
-; Languages
-&EN
-
-; Header
-#{"symbian_ua"},(0x200235D3), 0, 1, 1
-
-; Platform compatibility
-[0x101F7961], *, *, *,{"Series60ProductID"}
-
-; vendor
-%{"PJSIP"}
-:"PJSIP"
-
-; Target
-"C:\Symbian\9.1\S60_3rd_MR\epoc32\release\gcce\UREL\symbian_ua.exe"-"!:\sys\bin\symbian_ua.exe"
-"C:\Symbian\9.1\S60_3rd_MR\epoc32\data\z\private\10003a3f\apps\symbian_ua_reg.rSC"-"!:\private\10003a3f\import\apps\symbian_ua_reg.rSC"